#include <iostream.h>
#include <stdio.h>
#include "mpi.h"

#define N 10

void main (int argc, char *argv[])
{
	MPI_Init( &argc, &argv );
	int rank=-1;
	int size=-1;
	int Iter = 10000;

MPI_Comm_size( MPI_COMM_WORLD, &size );
cout<<"Number of processors : "<<size<<endl;

MPI_Comm_rank( MPI_COMM_WORLD, &rank );
cout<<"My Rank: "<<rank<<endl;

//int node=1;
int recv[N];
int send[N];

double t0=MPI_Wtime();

for (int i=0; i<Iter; i++)
{
	if (rank==0)
	{
		//int send[1000];//={20,30,40,50,60,70,80,90,100,110};
		printf ("Sending to second: %d integers..\n",N);fflush(stdout);
		MPI_Send( &send, N, MPI_INT, 1, 0, MPI_COMM_WORLD ); 
		
		MPI_Status	status;
		MPI_Recv( &recv, N, MPI_INT, 1 , 0, MPI_COMM_WORLD, &status ); 
		printf("Received from second\n");
	}
	if (rank==1)
	{
		//int send[10]={20,30,40,50,60,70,80,90,100,110};
		printf ("Sending to first: %d integers..\n", N);fflush(stdout);
		MPI_Send( &send, N, MPI_INT, 0, 0, MPI_COMM_WORLD ); 
		
		MPI_Status status;
		MPI_Recv( &recv, N, MPI_INT, 0, 0, MPI_COMM_WORLD, &status ); 
		printf("Received from first\n");
	}
}

double t1=MPI_Wtime();

MPI_Finalize();	

if (rank==0) {
	printf("Total time:%f\n", (t1-t0));
	double R = 2*Iter*10/(t1-t0);
	printf("R = %f\n", R);
}

}